#pragma once
#include "entities.hpp"
#include <sqlite3.h>
#include <string>
#include <iostream>
#include <array>

namespace db {
    // Путь к базе данных
    static std::string db_path;

    // Записывает путь к базе данных в db_path
    void databaseInit(std::string filename);

    // Открывает подключение к БД
    int databaseOpen();

    // Закрывает подключение к БД
    void databaseClose();

    // Создаёт необходимые таблицы
    void createTables();

    // Получает видео по его youtube id. Возвращает true, если видео было
    // найдено
    bool getVideoByYTID(std::string yt_id, video* output);

    // Получает автора видео по его youtube id. Возвращает true, если автор был
    // найден
    bool getAuthorByYTID(std::string yt_id, author* output);

    // Добавляет видео в базу данных. Заполняет свойство id при добавлении
    void addVideo(video* v);
    
    // Добавляет видео в базу данных
    void addAuthor(author* a);
}